if(com.tobwithu.wmn.p_getBoolPref("multiSession")){
  if(com.tobwithu.wmn.p_getBoolPref("keepSession")){
    com.tobwithu.wmn.getSid=function(){
      return getBrowser().selectedTab.getAttribute("wmnsid");
    };
    com.tobwithu.wmn.addTabListener=function(){
      var sid=com.tobwithu.wmn.getSid(); 
      if(sid!=""){
        gBrowser.tabContainer.addEventListener("TabOpen",
          function(event){
            gBrowser.tabContainer.removeEventListener("TabOpen",arguments.callee, false);
            var tab=event.target;
            tab.setAttribute("wmnsid",sid);
          }
        ,false);
      }
    };
    if(typeof openLinkIn != "undefined"){//ff4 or later
      com.tobwithu.wmn.openLinkIn=openLinkIn;
      openLinkIn=function(url, where, params){
        if(where=="tab"||where=="tabshifted")com.tobwithu.wmn.addTabListener();
        com.tobwithu.wmn.openLinkIn(url, where, params);
      }
    }else{//ff3
      com.tobwithu.wmn.openNewTabWith=openNewTabWith;
      openNewTabWith=function(aURL, aDocument, aPostData, aEvent, aAllowThirdPartyFixup,aReferrer){   
        com.tobwithu.wmn.addTabListener();        
        com.tobwithu.wmn.openNewTabWith(aURL, aDocument, aPostData, aEvent, aAllowThirdPartyFixup,aReferrer);
      };  
    }
  }
  com.tobwithu.wmn.onLoadFF=function(){
    if(com.tobwithu.wmn.p_getBoolPref("keepSession")){
      if(window.opener){//set sid for new window
        var tab0=window.opener.gBrowser.selectedTab;
        var sid=tab0.getAttribute("wmnsid");
        if(sid!="")gBrowser.selectedTab.setAttribute("wmnsid",sid);
      }
    }
    if(gBrowser.addTabsProgressListener)gBrowser.addTabsProgressListener({    
      onStateChange:function(browser,webProgress, request, state, status){
      com.tobwithu.wmn.nsIWebMailNotifier.onStateChange(browser,webProgress, request, state, status);
      }
    });
  }
}

com.tobwithu.wmn.showToolbarButton=function(){
  var id="wmn-toolbar-button";
  var anchor="search-container";
  try {
    var toolbar = document.getElementById("nav-bar");
    var curSet = toolbar.currentSet.split(",");
    if (curSet.indexOf(id) == -1){
      var ind = curSet.indexOf(anchor);
      var pos = ind==-1?curSet.length:ind;
      var set = curSet.slice(0, pos).concat(id).concat(curSet.slice(pos)).join(",");

      toolbar.setAttribute("currentset", set);
      toolbar.currentSet = set;
      document.persist("nav-bar", "currentset");
      try {
         BrowserToolboxCustomizeDone(true);
      }catch (e) { }
    }
  }catch(e) { }
}
com.tobwithu.wmn.initTabMenu=function(){
  if(!document.getElementById("wmnTabMenu"))return;//ff2
  var menu=gBrowser.tabContextMenu;
  if(!menu)menu=document.getAnonymousElementByAttribute(gBrowser, "anonid", "tabContextMenu");//ff 2.0
  if(!menu)return;
  var mi = menu.childNodes;
  var n=0;
  var sep=null;
  for(var i=0;i<mi.length;i++) {
    if (mi[i].localName=="menuseparator"){
      if(n==1){sep=mi[i];break;}
      ++n;
    }
  }
  var menu2=document.getElementById("wmnTabMenu").firstChild;
  menu2.addEventListener("popupshowing",com.tobwithu.wmn.onPopupShow,false);
  var wmn=com.tobwithu.wmn.nsIWebMailNotifier;
  var hdls=wmn.webMailHandlers;
  var tf=com.tobwithu.wmn.p_getBoolPref("autoLoginDefaultAccount");
  var sid=gBrowser.selectedTab.getAttribute("wmnsid");
  var show=false;
  for(var i=0;i<hdls.length;i++){
    var o=hdls[i];
    if(!o.enabled)continue;
    if(!tf||!wmn.isDefault(o.id,o.user)){
      show=true;
      var em=document.createElement("menuitem");
      em.ind=o.ind;
		  em.setAttribute("label",o.accName);
      em.setAttribute("type","checkbox");
      em.addEventListener("command",function(){com.tobwithu.wmn.setSessionId(this.ind);},false);
      em.setAttribute("val",o.ind.toString());
      menu2.appendChild(em);
    }
  }
  if(show){
    menu.insertBefore(document.createElement("menuseparator"),sep);
    menu.insertBefore(document.getElementById("wmnTabMenu"), sep);
  }
}
com.tobwithu.wmn.onPopupShow=function(event){
  var tab=document.popupNode;
  var sid=tab.getAttribute("wmnsid");
  if(sid=="")sid=-1;
  var list=document.getElementById("wmnTabMenu").firstChild.childNodes;
  for(var i=0;i<list.length;i++){
    var val=list[i].getAttribute("val");
    if(val!=sid)list[i].removeAttribute("checked");
    else list[i].setAttribute("checked",true);
  }
}
com.tobwithu.wmn.setSessionId=function(sid){
  com.tobwithu.wmn.nsIWebMailNotifier.setSessionId(window,document.popupNode,sid);
}
